SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PC_ExternalToWorkingReport]') and OBJECTPROPERTY(id, N'IsView') = 1) 
drop view [dbo].[PC_ExternalToWorkingReport]
GO

DECLARE @sqlcmd NVARCHAR(MAX)

SELECT @sqlcmd = 
'CREATE VIEW PC_ExternalToWorkingReport AS
SELECT PB_SC_ServiceCallDetails.ApplicationType AS SourceApp
	   ,PB_SC_ServiceCallDetails.ServicecallID AS SourceDocID
	   ,PB_SC_ServiceCallDetails.Position AS SourceDocLine
	   ,ServiceCallNo AS SourceDocNo
	   ,27098368 AS SourceDocCRRefType --Tipo riferimento documento di origine (27098368 = Chiamata)--
	   ,"" AS SourceDocIDOption --ID Documento Opzionale per collegamento con documenti per cui non sono suffienti le chiavi precedenti (convert(varchar(10),A.ClosingDate,112) = Calendario risorse)--
	   ,PB_SC_ServiceCallDetails.ActivityNo
	   ,PB_SC_ServiceCallDetails.Job AS Job
	   ,Technician AS Employee
	   ,PB_SC_ServiceCallDetails.PostingDate as WorkingReportDate
	   ,((DATEPART(HOUR, [StartingTime]) * 3600) + (DATEPART(MINUTE, [StartingTime]) * 60) +(DATEPART(SECOND, [StartingTime]))) as StartHour
	   ,((DATEPART(HOUR, [EndingTime]) * 3600) + (DATEPART(MINUTE, [EndingTime]) * 60) +(DATEPART(SECOND, [EndingTime]))) as EndHour
	   ,CASE WHEN LineType = 200605697 AND SlotType = 204603392 THEN ComputedHours ELSE 0 END AS OrdinaryHours --Tipo riga Manodopera e Regime Ordinario--
	   ,CASE WHEN LineType = 200605697 AND SlotType <> 204603392 THEN ComputedHours ELSE 0 END AS OvertimeHours --Tipo riga Manodopera e Regime diverso da Ordinario-- 
	   ,CASE WHEN LineType = 200605705 THEN ComputedHours ELSE 0 END AS TravelHours --Tipo riga Tempo Viaggio--
	   ,0 AS VacationLeaveHours
	   ,0 AS SickLeaveHours
	   ,0 AS CustomHours1
	   ,0 AS CustomHours2
	   ,0 AS CustomHours3
	   ,0 AS CustomHours4
	   ,CASE
			WHEN LineType = 200605697 OR LineType = 200605705 THEN 13238277 /*manodopera, tempo viaggio -> manodopera*/
			WHEN LineType = 200605698 OR LineType = 200605703 OR LineType = 200605704 OR LineType = 200605706 OR LineType = 200605708 OR LineType = 200605709 THEN 13238276 /*servizi, diritto fisso, costo km, diritto di zona, rimborso trasferta, vitto e alloggio -> servizio*/
			WHEN LineType = 200605702 THEN 13238275 /*altro -> altro*/
		END AS ComponentType
	  ,PB_SC_ServiceCallDetails.Item AS Component
	  ,ItemDescription AS ComponentDescription
	  ,UoM
	  ,Qty
	  ,CASE WHEN LineType = 200605698 OR LineType = 200605702 OR LineType = 200605703 OR LineType = 200605704 OR LineType = 200605706 OR LineType = 200605708 OR LineType = 200605709 THEN UnitCost ELSE 0 END AS UnitValue
	  ,0.0 AS Cost
	  ,"" AS DiscountFormula
	  ,0.0 AS DiscountAmount
	  ,"" AS WorkingStep
	  ,"" AS ExternalReference
FROM 
	PB_SC_ServiceCallDetails 
	JOIN PB_SC_ServiceCall ON 
								PB_SC_ServiceCallDetails.ApplicationType = PB_SC_ServiceCall.ApplicationType
							AND PB_SC_ServiceCallDetails.ServiceCallType = PB_SC_ServiceCall.ServiceCallType
							AND PB_SC_ServiceCallDetails.ServiceCallID = PB_SC_ServiceCall.ServiceCallID
	JOIN PB_SC_ServiceCallActivities ON 
										PB_SC_ServiceCallDetails.ApplicationType = PB_SC_ServiceCallActivities.ApplicationType
							AND PB_SC_ServiceCallDetails.ServiceCallType = PB_SC_ServiceCallActivities.ServiceCallType
							AND PB_SC_ServiceCallDetails.ServiceCallID = PB_SC_ServiceCallActivities.ServiceCallID 
							AND PB_SC_ServiceCallDetails.ActivityNo = PB_SC_ServiceCallActivities.ActivityNo
	JOIN MA_Jobs ON MA_Jobs.Job = PB_SC_ServiceCallDetails.Job
WHERE 
	(
		(
			(
				LineType = 200605697  --Tipo Riga Manodopera-- 
				OR
				LineType = 200605705 --Tipo Riga Viaggio-- 
			) AND
			Technician <> "" AND ComputedHours <> 0 AND --Tecnico diverso da vuoto e Ore Calcolate diverse da 0--
			(
				PB_SC_ServiceCallDetails.Job <> ""
				AND MA_Jobs.Disabled = 0
				AND PB_SC_ServiceCallDetails.ApplicationType = 1311244288 --Tipo Applicazione Service--
				AND PB_SC_ServiceCallDetails.ServiceCallType = 1312686080 --Tipo Documento Chiamata--
				AND (PB_SC_ServiceCallActivities.ActivityStatus = 197984257 OR PB_SC_ServiceCallActivities.ActivityStatus = 197984259) -- Stato Attività Chiusa o Effettuata--
			)
		)

		OR

		(
			(
				LineType <> 200605697 --Tipo Riga Manodopera-- 
				AND 
				LineType <> 200605705 --Tipo Riga Viaggio--
				AND 
				LineType <> 200605707 --Tipo Riga Note--
				AND
				LineType <> 200605699 --Tipo Riga Merce--
				AND
				LineType <> 200605700 --Tipo Riga Consumabili--
			)
			AND
			Qty <> 0 AND --Quantità servizio diversa da 0--
			(
				PB_SC_ServiceCallDetails.Job <> ""
				AND MA_Jobs.Disabled = 0
				AND PB_SC_ServiceCallDetails.ApplicationType = 1311244288 --Tipo Applicazione Service--
				AND PB_SC_ServiceCallDetails.ServiceCallType = 1312686080 --Tipo Documento Chiamata--
				AND (PB_SC_ServiceCallActivities.ActivityStatus = 197984257 OR PB_SC_ServiceCallActivities.ActivityStatus = 197984259) -- Stato Attività Chiusa o Effettuata--
			)
		)
	)
	AND NOT EXISTS
	(
		SELECT *
		FROM
			PC_WRReferences
		WHERE
			PC_WRReferences.SourceApp = PB_SC_ServiceCallDetails.ApplicationType
		AND PC_WRReferences.SourceDocID = PB_SC_ServiceCallDetails.ServiceCallID
		AND PC_WRReferences.SourceDocLine = PB_SC_ServiceCallDetails.Position
		AND PC_WRReferences.SourceDocCRRefType = 27098368
		AND PC_WRReferences.SourceDocIDOption = ""
	)'

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PB_SC_ServiceCallDetails]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
 EXEC sp_executesql @sqlcmd
END

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO